﻿package {    
    import flash.events.Event;
    import flash.events.EventDispatcher;
    import flash.events.IOErrorEvent;
    import flash.events.SecurityErrorEvent;
    import flash.net.FileFilter;
    import flash.net.URLLoader;
    import flash.net.URLRequest;
    
    // AIR STUFF
    //import flash.filesystem.*;
    
    import TextDataEvent;
/* XmlLoader- Handles the loading of xml so that it can be input into a flash project easily
*/

  public class XmlLoader extends EventDispatcher{
  
  private var XMLPath:String = "";
  private var XMLOrText:String;
  private var XMLIndex:int;
  private var RawXMLData:XML;
  
  public static var DATAREADY:String = "Data Ready";
  
  // Class constructor
  public function XmlLoader(_PathToData:String, _XMLOrText:String, _XMLIndex:int,_Mode:String = "actionscript"):void
  {

      if (_Mode == "actionscript") {
          
      // Create a data loader
         var AbstractDataLoader:URLLoader = new URLLoader();
      // Swaps any \ slashes with / slashes
         _PathToData = _PathToData.replace(/\\/g, "/");
         
      // Set the type of file
      XMLOrText = _XMLOrText;

      // Add Events
      AbstractDataLoader.addEventListener(Event.COMPLETE, HandleData, false, 0, true);
      AbstractDataLoader.addEventListener(IOErrorEvent.IO_ERROR, ReportError, false, 0, true);
      AbstractDataLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, ReportSecurityError, false, 0, true);
      
      // Load the xml/text file
      AbstractDataLoader.load(new URLRequest(_PathToData));
      } else {
          // The event that will be dispatched reguardless of what happens
         //    var evt:TextDataEvent;
          // Add the app prefix to the path
        //     _PathToData = "app:/" + _PathToData;

        // Create a file
        //   var FileToLoad:File = new File(_PathToData);
    //       var DataStream:FileStream = new FileStream();
   
           try {
    //           DataStream.open(FileToLoad, FileMode.READ);
    //           RawXMLData = XML(DataStream.readUTFBytes(DataStream.bytesAvailable));
//               DataStream.close();
    //           evt = new TextDataEvent(DataLoader.DATAREADY, false, false, RawXMLData);
    //           dispatchEvent(evt);
           } catch (e:Error){
    //           trace("Data Load from file failed");
    //           evt = new TextDataEvent(DataLoader.DATAREADY, false, false, null);
    //           dispatchEvent(evt);
           }
           
      }
      
      // Set the XML Index
      XMLIndex = _XMLIndex;
  }
  
  private function HandleData(e:Event):void {
      e.currentTarget.removeEventListener(Event.COMPLETE, HandleData);
      if(XMLOrText == "xml") {
        XML.ignoreWhitespace = true;
        RawXMLData = new XML(e.target.data);

        var evt:TextDataEvent = new TextDataEvent(XmlLoader.DATAREADY, false, false, RawXMLData);
        dispatchEvent(evt);
        
      } else {

        // Call the function that is in the parent class with the text data
        //MovieClip(this.parent).Scene2LogicStep3(e.target.data);
      }
      
  }
  
  // If we get an IO error, still throw DATAREADY but send null instead of xml
  private function ReportError(e:IOErrorEvent):void {
      trace("DataLoader IO Error");
      var evt:TextDataEvent = new TextDataEvent(XmlLoader.DATAREADY, false, false, null);
      dispatchEvent(evt);
  }
  
  private function ReportSecurityError(e:SecurityError):void {
      trace("DataLoader Security Error");
      var evt:TextDataEvent = new TextDataEvent(XmlLoader.DATAREADY, false, false, null);
      dispatchEvent(evt);
  }
  
 }
}